/* 
 * Copyright (c) 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: list.gi,v 1.3 2002/06/04 11:54:12 malekith Exp $
 *
 * Standard library for Gont, List module implementation.
 */

union <'a>t {
	void Nil;
	*['a, <'a>t] Cons;
}

int length(<'a>t l);
void iter(*(void ('a)) f, <'a>t l);
<'b>t map(*('b ('a)) f, <'a>t l);
<'a>t concat(<'a>t x, <'a>t y);
<'a>t filter(*(bool ('a)) f, <'a>t l);
'a fold_left(*('a ('a, 'b)) f, 'a init, <'b>t li);
<'a>t qsort(*(int ('a, 'a)) cmp, <'a>t l);

<'a>t cons1('a d1);
<'a>t cons2('a d1, 'a d2);
<'a>t cons3('a d1, 'a d2, 'a d3);
<'a>t cons4('a d1, 'a d2, 'a d3, 'a d4);

/* EOF */
