// Test multiple assignment
// $Id: t7.g,v 1.4 2002/02/25 11:15:11 malekith Exp $

void print_pair(*[int, int] p)
{
	let [x, y] = p in {
		print_string("[");
		print_int(x);
		print_string(",");
		print_int(y);
		print_string("] ");
	}
}

section init
{
	int x = 1;
	int y = 2;

	print_pair([x,y]);
	[x,y] = [y,x];
	print_pair([x,y]);
	[x,y] = [y,x];
	print_pair([x,y]);

	*[int, int] p;
	p = [3,4];
	[x,y] = p;
	print_pair([x,y]);
	[x,y] = [y,x];
	print_pair([x,y]);

	let [a, b] = [x, y] in {
		x = b;
		y = a;
	}
	print_pair([x,y]);

	switch [x, y] {
	case [a, b]:
		x = b;
		y = a;
	}
	print_pair([x,y]);
	
	print_string(".\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: [1,2] [2,1] [1,2] [3,4] [4,3] [3,4] [4,3] .
 */
